<?php
// Ce fichier ne sera execute qu'une fois
if (defined("_INC_CALCUL")) return;
define("_INC_CALCUL", "1");

// ce fichier excute un squelette.

include_ecrire("inc_index.php3");
include_ecrire("inc_texte.php3");
include_ecrire("inc_filtres.php3");
include_ecrire("inc_lang.php3");
include_ecrire("inc_documents.php3");
include_local ("inc-runtime.php3");
if (file_exists("inc-urls.php3")) {
	include_local ("inc-urls.php3");
}
else {
	include_local ("inc-urls-dist.php3");
}

# Ce fichier peut contenir une affectation de $dossier_squelettes  indiquant
# le rpertoire du source des squelettes (les pseudo-html avec <BOUCLE...)

if (file_exists("mes_fonctions.php3")) 
    include_local ("mes_fonctions.php3");

# Provoque la recherche du squelette $fond d'une $lang donne,
# et l'applique sur un $contexte pour un certain $cache.
# Retourne un tableau de 3 lments:
# 'texte' => la page calcule
# 'process_ins' => 'html' ou 'php' si prsence d'un '<?php'
# 'invalideurs' => les invalideurs (cf inc-calcul-squel)

# La recherche est assure par la fonction cherche_squelette
# dfinie dans inc-chercher, fichier non charg s'il existe un fichier
# mon-chercher dans $dossier_squelettes ou dans le rep principal de Spip,
# pour charger une autre dfinition de cette fonction.

# L'excution est prcde du chargement ventuel d'un fichier homonyme
# de celui du squelette mais d'extension .php  pouvant contenir:
# - des filtres
# - des fonctions de traduction de balise (cf inc-index-squel)

function cherche_page($fond, $cache, $contexte, $id_rubrique, $lang='') 
{
  global $dossier_squelettes;

  $dir = "$dossier_squelettes/mon-chercher.php3";
  include((file_exists($dir) ? $dir : "inc-chercher.php3"));

  $skel = chercher_squelette($fond,
			     $id_rubrique,
			     $dossier_squelettes ? "$dossier_squelettes/" :'',
			     $lang);

  $dir = "$skel" . '_fonctions.php3';
  if (file_exists($dir)) include($dir);

  $fonc =  ramener_squelette($skel);
  $timer_a = explode(" ", microtime());
  $page =  $fonc(array('cache' =>$cache), array($contexte));
  $timer_b = explode(" ", microtime());
  $timer = ceil(1000*($timer_b[0] + $timer_b[1] - $timer_a[0] - $timer_a[1]));
  spip_log("Page $skel: " . strlen($page['texte']) . " octets, $timer ms");
  return $page;
}

function cherche_page_incluse($cache, $contexte)
{
  $contexte_inclus = $contexte['contexte'];
  return cherche_page($contexte['fond'], 
		      $cache,
		      $contexte_inclus,
		      $contexte_inclus['id_rubrique']);
}

function calculer_page_globale($cache, $fond, $var_recherche)
 {
   $contexte = $GLOBALS['HTTP_GET_VARS'];
   if ($GLOBALS['date'])
    $contexte['date'] = $contexte['date_redac'] = normaliser_date($GLOBALS['date']);
  else
    $contexte['date'] = $contexte['date_redac'] = date("Y-m-d H:i:s");
  
  $lang = lire_meta('langue_site');
  if ($contexte['lang'])
    $lang = $contexte['lang'];	// si inc-urls veut fixer la langue

	// Calcul de la rubrique associee a la requete
	// (selection de squelette specifique)

  if ($id = $contexte['id_rubrique']) {
    $id_rubrique_fond = $id;
    if ($row = spip_fetch_array(spip_query("
SELECT lang FROM spip_rubriques WHERE id_rubrique='$id'")))
      if ($row['lang']) $lang = $row['lang'];
  }
  else if ($id  = $contexte['id_breve']) {
    if ($row = spip_fetch_array(spip_query("
SELECT id_rubrique FROM spip_breves WHERE id_breve='$id'"))) {
      $id_rubrique_fond = $row['id_rubrique'];
      if ($row = spip_fetch_array(spip_query("
SELECT lang FROM spip_rubriques WHERE id_rubrique='$id_rubrique_fond'")))
	if ($row['lang']) $lang = $row['lang'];
    }
  }
  else if ($id = $contexte['id_syndic']) {
    if ($row = spip_fetch_array(spip_query("
SELECT id_rubrique FROM spip_syndic WHERE id_syndic='$id'"))) {
      $id_rubrique_fond = $row['id_rubrique'];
      if ($row = spip_fetch_array(spip_query("
SELECT lang FROM spip_rubriques WHERE id_rubrique='$id_rubrique_fond'")))
	if ($row['lang']) $lang = $row['lang'];
    }
  }
  else if ($id = $contexte['id_article']) {
    if ($row = spip_fetch_array(spip_query("
SELECT id_rubrique,lang FROM spip_articles WHERE id_article='$id'"))) {
      $id_rubrique_fond = $row['id_rubrique'];
      if ($row['lang']) $lang = $row['lang'];
    }
  }
  else {
    $id_rubrique_fond = 0;
  }
  $signale_globals = "";  
  foreach(array('id_parent', 'id_rubrique', 'id_article', 'id_auteur',
		'id_breve', 'id_forum', 'id_secteur', 'id_syndic', 'id_syndic_article', 'id_mot', 'id_groupe', 'id_document') as $val)
    {
      if ($contexte[$val])
	$signale_globals .= '$GLOBALS[\''.$val.'\'] = '.intval($contexte[$val]).";";
    }
  $page = cherche_page($fond, $cache, $contexte, $id_rubrique_fond, $lang);
  $texte = $page['texte'];

  if ($var_recherche)
    {
      include_ecrire("inc_surligne.php3");
#      spip_log("Recherche : $var_recherche");
      $texte = surligner_mots($texte, $var_recherche);
    } 

  return array('texte' => 
	       (($page['process_ins'] || (!$signale_globals)) ? $texte :
		('<'."?php $signale_globals ?".'>'.$texte)),
	       'process_ins' => $page['process_ins'],
	       'invalideurs' => $page['invalideurs']);
}

function cherche_page_incluante($cache, $contexte)
{
    // si le champ chapo commence par '=' c'est une redirection.
    // on en profite pour ne pas cacher un article demande avant publication
  if ($id_article = intval($GLOBALS['id_article'])) {
    $page = spip_fetch_array(spip_query("
SELECT	chapo
FROM	spip_articles
WHERE	id_article='$id_article' AND statut='publie'
"));
    if (!$page) return '';
    $page = $page['chapo'];
    if (substr($page, 0, 1) == '=') {
      include_ecrire('inc_texte.php3');
      list(,$page) = extraire_lien(array('','','',substr($page, 1)));
      if ($page) // sinon les navigateurs pataugent
	{

	  $page = addslashes($page);
	  return array('texte' =>
		       ("<". "?php header(\"Location: $page\"); ?" . ">"),
		       'process_ins' => 'php');
	       }
    }
  }
  return calculer_page_globale($cache,
			       $contexte['fond'],
			       $contexte['var_recherche']);
}
    

# Construit et excute une requte SQL correspondant  une balise Boucle
# Si erreur SQL, notifie dans le flux de sortie et termine le processus.
# Sinon, retourne la ressource interrogeable par fetch_row ou fetch_array.
# Elle peut etre rdfinie pour s'interfacer avec d'autres serveurs SQL
# Recoit en argument:
# - le tableau des champs  ramener
# - le tableau des tables  consulter
# - le tableau des conditions  remplir
# - le critre de regroupement
# - le critre de classement
# - le critre de limite
# - une sous-requete ventuelle (MySQL > 4.1)
# - un compteur de sous-requete
# - le nom de la table
# - le nom de la boucle (pour le message d'erreur ventuel)

# ATTENTION: par souci d'efficacit, spip_query N'EST PAS appele
# le traitement de table_prefix tant effectu ici plus proprement

function spip_abstract_select($s, $f, $w, $g, $o, $l, $sous, $cpt, $table, $id)
{
 if ($GLOBALS["mysql_rappel_connexion"] AND $DB = $GLOBALS["spip_mysql_db"])
        $DB = "`$DB`";
 $DB .= $GLOBALS["table_prefix"] . '_';
 $q = "\nFROM\t$DB".
    join(",\n\t$DB", $f) .
    ((!$w) ? "" : ("\nWHERE\t".join("\n AND\t", $w))) .
    ($g ? "\nGROUP BY $g" : '') .
    ($o ? "\nORDER BY $o" : '') .
    ($l ? "\nLIMIT $l" : '');
  $q = (!$sous ? 
	("\nSELECT\t". join(",\n\t", $s) . $q) :
	("\nSELECT\tS_" . join(",\n\tS_", $s) .
	 "\nFROM ($s,\n\tCOUNT(" . $sous .
	 ") AS compteur $q)\n AS S_$table\nWHERE compteur= " . 
	 $cpt));
#  spip_log("Boucle $id: $q");
  if (!($result = @mysql_query($q)))
    {
      include_local("inc-debug-squel.php3");
      echo erreur_requete_boucle($q, $id, $table);
      exit;
    }
  else return $result;
}


# Fonctions appelant le serveur SQL
# et appeles par les squelettes (insertion dans le code trop lourde)

# Critere {branche} : recuperer les descendants d'une rubrique

function calcul_generation ($generation) {
	$lesfils = array();
	$result = spip_query("SELECT id_rubrique FROM spip_rubriques WHERE id_parent IN ($generation)");
	while ($row = spip_fetch_array($result))
		$lesfils[] = $row['id_rubrique'];
	return join(",",$lesfils);
}
function calcul_branche ($generation) {
	if ($generation) {
		$branche[] = $generation;
		while ($generation = calcul_generation ($generation))
			$branche[] = $generation;
		return join(",",$branche);
	} else
		return '0';
}

function query_auteurs($larticle)
{
  $auteurs = "";
  if ($larticle)
    {
      $result_auteurs = spip_query("
SELECT	auteurs.nom, auteurs.email 
FROM	spip_auteurs AS auteurs,
	spip_auteurs_articles AS lien
WHERE	lien.id_article=$larticle
 AND	auteurs.id_auteur=lien.id_auteur
");

      while($row_auteur = spip_fetch_array($result_auteurs)) {
	$nom_auteur = typo($row_auteur["nom"]);
	$email_auteur = $row_auteur["email"];
	if ($email_auteur) {
	  $auteurs[] = "<A HREF=\"mailto:$email_auteur\">$nom_auteur</A>";
	}
	else {
	  $auteurs[] = "$nom_auteur";
	}
      }
    }
  return (!$auteurs) ? "" : join($auteurs, ", ");
}

# fonction pour la balise FORMULAIRE_FORUM
# $Cache est pass par rfrence pour viter sa recopie mais n'est pas affect

function boutons_de_forum($idr, $idf, $ida, $idb, $ids, $titre, $table, &$Cache, $forum)
{
  if (($table == 'forums') || !$table)
    {
      $forum = spip_fetch_object(spip_query("
SELECT	accepter_forum
FROM	spip_articles
WHERE	id_article='" . ($ida ? $ida : substr(lire_meta("forums_publics"),0,3)) . "'
")); 
      $forum = ($forum ? $forum->accepter_forum : substr(lire_meta("forums_publics"),0,3));
    }
  if ($forum=="non") return '';
  // si FORMULAIRE_FORUM a t employ hors d'une boucle,
  // on n'a pas pu dterminer titre et table  la compil
  if (!$table)
    {
      if ($idf)
	{
	  $r = "SELECT titre FROM spip_forum WHERE id_forum = $idf";
	  $table = "forum";
	}
      else if ($idr)
	{
	  $r = "SELECT titre FROM spip_rubriques WHERE id_rubrique = $idr";
	  $table = "rubriques";
	}
      else if ($ida)
	{
	  $r = "SELECT titre FROM spip_articles WHERE id_article = $ida";
	  $table = "articles";
	}
      else if ($idb)
	{
	  $r = "SELECT titre FROM spip_breves WHERE id_breve = $idb";
	  $table = "breves";
	}
      else if ($id_syndic)
	{
	  $table = "syndic";
	  $r = "SELECT nom_site AS titre FROM spip_syndic WHERE id_syndic = $ids";
	}
      else
	{
	  $r = "SELECT '".addslashes(_T('forum_titre_erreur'))."' AS titre";
	}
      $r = spip_fetch_object(spip_query($r));
      $titre = $r->titre;
	}

  $titre = ('> ' . supprimer_numero(ereg_replace ('^[>[:space:]]*', '',$titre)));
  $url = $GLOBALS[HTTP_GET_VARS][url];
  if (!$url) 
    $url = substr($GLOBALS[PHP_SELF], strrpos($GLOBALS[PHP_SELF], '/')+1) . 
      substr($GLOBALS[REQUEST_URI], strpos($GLOBALS[REQUEST_URI], '?')); 
  $retour_forum = $GLOBALS['retour'];
  if (!$retour_forum)
    $retour_forum = rawurlencode($url);
  else $retour_forum = ereg_replace('&recalcul=oui','',$retour_forum);

  $lacible = "
	include_local('inc-forum.php3');
spip_log('$url');
	lang_select(\$GLOBALS['spip_lang']);
	echo retour_forum('$idr','$idf','$ida','$idb','$ids',\"$titre\",'$table', '$forum', '$url', \"
	<input type=hidden name='retour' value='$retour_forum' />
	<input type=hidden name='var_cache' value='$Cache[cache]' />
	<input type=hidden name='ajout_forum' value='oui' />
	<input type=hidden name='forum_id_rubrique' value='$idr' />
	<input type=hidden name='forum_id_parent' value='$idf' />
	<input type=hidden name='forum_id_article' value='$ida' />
	<input type=hidden name='forum_id_breve' value='$idb' />
	<input type=hidden name='forum_id_syndic' value='$ids' />
	" .
	(($forum != 'pri') ? '' : ((_T('forum_info_modere'). '<p>'))) . 
	"\");
	lang_dselect();";
  return
	 (($forum != "abo") ? ("<" . "?php" . $lacible . "?" . ">"):
	   ("<" . "?php " . "if (\$GLOBALS[\"auteur_session\"]) {
		$lacible}" . 'else
		{
		include_local("inc-login.php3"); 
		login(new Link("' . $url . '"), false, true); }' . 
	    "?". ">"));
}


?>
